searchData={"content_type":"text/markdown","items":[{"doc":"ExTimer module.","ref":"ExTimer.html","title":"ExTimer","type":"module"},{"doc":"add new timer to send msg after time milliseconds.","ref":"ExTimer.html#add/3","title":"ExTimer.add/3","type":"function"},{"doc":"```elixir\niex> state = %{timers: [], elapsed_ticks: 0}\n%{elapsed_ticks: 0, timers: []}\niex> state = ExTimer.add(state, {:handler, :name, \"uhaha\"}, 2000)\n%{elapsed_ticks: 0, timers: [%ExTimer.Node{delay: 2000, msg: {:handler, :name, \"uhaha\"}}]}\niex> [timer] = state.timers\n[%ExTimer.Node{delay: 2000, msg: {:handler, :name, \"uhaha\"}}]\niex> timer.msg == {:handler, :name, \"uhaha\"}\ntrue\niex> timer.delay == 2000\ntrue\n\n```","ref":"ExTimer.html#add/3-examples","title":"Examples - ExTimer.add/3","type":"function"},{"doc":"delete all the registerd timers.","ref":"ExTimer.html#clear/2","title":"ExTimer.clear/2","type":"macro"},{"doc":"```elixir\niex> state = %{timers: [%ExTimer.Node{msg: {:handler, :name, \"uhaha\"}, delay: 2000}], elapsed_ticks: 0}\n%{elapsed_ticks: 0, timers: [%ExTimer.Node{delay: 2000, msg: {:handler, :name, \"uhaha\"}}]}\niex> ExTimer.clear(state)\n%{timers: [], elapsed_ticks: 0}\n\n```","ref":"ExTimer.html#clear/2-examples","title":"Examples - ExTimer.clear/2","type":"macro"},{"doc":"return true if found the timer at the given msg, otherwise return false","ref":"ExTimer.html#exist?/2","title":"ExTimer.exist?/2","type":"function"},{"doc":"```elixir\niex> state = %{timers: [%ExTimer.Node{msg: {:handler, :name, \"uhaha\"}, delay: 2000}], elapsed_ticks: 0}\n%{\n  elapsed_ticks: 0,\n  timers: [%ExTimer.Node{delay: 2000, msg: {:handler, :name, \"uhaha\"}}]\n}\niex> ExTimer.exist?(state, {:handler, :name, \"uhaha\"})\ntrue\n\n```","ref":"ExTimer.html#exist?/2-examples","title":"Examples - ExTimer.exist?/2","type":"function"},{"doc":"get the minimum time(milliseconds) for the timer to expired.","ref":"ExTimer.html#next_expire_ticks/2","title":"ExTimer.next_expire_ticks/2","type":"function"},{"doc":"```elixir\ndef handle_info(:tick, state) do\n  now = System.system_time(:millisecond)\n  delta_ticks = now - state.last_update_tick\n  state = put_in(state.last_update_tick, now)\n  state = ExTimer.update(state, delta_ticks)\n\n  Process.send_after(self(), :tick, ExTimer.next_expire_ticks(state, 1000))\n  {:noreply, state}\nend\n```","ref":"ExTimer.html#next_expire_ticks/2-examples","title":"Examples - ExTimer.next_expire_ticks/2","type":"function"},{"doc":"delete the previous registerd timer.","ref":"ExTimer.html#remove/2","title":"ExTimer.remove/2","type":"function"},{"doc":"```elixir\niex> state = %{timers: [%ExTimer.Node{msg: {:handler, :name, \"uhaha\"}, delay: 2000}], elapsed_ticks: 0}\n%{\n  elapsed_ticks: 0,\n  timers: [%ExTimer.Node{delay: 2000, msg: {:handler, :name, \"uhaha\"}}]\n}\niex> ExTimer.remove(state, {:handler, :name, \"uhaha\"})\n%{timers: [], elapsed_ticks: 0}\n\n```","ref":"ExTimer.html#remove/2-examples","title":"Examples - ExTimer.remove/2","type":"function"},{"doc":"call the callback handler (handle_info) for the timer that has elapsed.","ref":"ExTimer.html#update/2","title":"ExTimer.update/2","type":"macro"},{"doc":"```elixir\nnow = System.system_time(:millisecond)\ndelta_ticks = now - state.last_update_tick\nstate = put_in(state.last_update_tick, now)\nstate = ExTimer.update(state, delta_ticks)\n\n```","ref":"ExTimer.html#update/2-examples","title":"Examples - ExTimer.update/2","type":"macro"},{"doc":"","ref":"ExTimer.html#t:state/0","title":"ExTimer.state/0","type":"type"},{"doc":"","ref":"ExTimer.html#t:time_ms/0","title":"ExTimer.time_ms/0","type":"type"},{"doc":"","ref":"ExTimer.html#t:timer_node/0","title":"ExTimer.timer_node/0","type":"type"},{"doc":"","ref":"ExTimer.html#t:timer_node_msg/0","title":"ExTimer.timer_node_msg/0","type":"type"},{"doc":"","ref":"ExTimer.Node.html","title":"ExTimer.Node","type":"module"},{"doc":"","ref":"ExTimer.Node.html#t:msg/0","title":"ExTimer.Node.msg/0","type":"type"},{"doc":"","ref":"ExTimer.Node.html#t:t/0","title":"ExTimer.Node.t/0","type":"type"},{"doc":"","ref":"ExTimer.Node.html#t:time_ms/0","title":"ExTimer.Node.time_ms/0","type":"type"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}